package src;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import java.util.LinkedList;
import java.util.List;
import java.util.Random;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class FormBoat {
    protected DrawingBoat _drawingBoat = new DrawingBoat();

    JPanel PanelWrapper;
    private JPanel PictureBox;
    private JToolBar StatusStrip;
    private JLabel StatusStripLabelSpeed;
    private JLabel StatusStripLabelWeight;
    private JLabel StatusStripLabelColor;
    private JButton ButtonCreate;
    private JButton ButtonDown;
    private JButton ButtonUp;
    private JButton ButtonLeft;
    private JButton ButtonRight;

    private List<JComponent> __controls;

    // Конструктор формы
    public FormBoat() {
        // Инициализируем список элементов управления для их перерисовки
        InitializeControlsRepaintList();

        ButtonUp.setName("ButtonUp");
        ButtonDown.setName("ButtonDown");
        ButtonLeft.setName("ButtonLeft");
        ButtonRight.setName("ButtonRight");

        // Обработчик нажатия кнопки "Создать"
        ButtonCreate.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                // Создаем новый объект отрисовки лодки
                _drawingBoat = new DrawingBoat();
                Random random = new Random();

                // Инициализируем обхект отрисовки
                _drawingBoat.Init(random.nextInt(100, 300), random.nextInt(1000, 2000),
                        new Color(random.nextInt(256), random.nextInt(256), random.nextInt(256)));

                // Устанавливаем позицию и размеры объекта отрисовки
                _drawingBoat.SetPosition(random.nextInt(10, 100), random.nextInt(10, 100),
                        PictureBox.getWidth(), PictureBox.getHeight());

                // Обновляем информацию в статусбаре
                StatusStripLabelSpeed.setText("Скорость: " + _drawingBoat.entityBoat.Speed + " ");
                StatusStripLabelWeight.setText("Вес: " + _drawingBoat.entityBoat.Weight + " ");
                Color color = _drawingBoat.entityBoat.BodyColor;
                StatusStripLabelColor.setText("Цвет: (" + color.getRed() + ", " + color.getGreen() + ", " + color.getBlue() + ")");

                // Перерисовываем содержимое
                Draw();
            }
        });

        // Обработчик изменения размеров формы
        PanelWrapper.addComponentListener(new ComponentAdapter() {
            @Override
            public void componentResized(ComponentEvent e) {
                super.componentResized(e);

                // Изменяем граници области отрисовки для объекта отрисовки
                _drawingBoat.ChangeBorders(PictureBox.getWidth(), PictureBox.getHeight());

                // Перерисовываем содержимое
                Draw();
            }
        });

        ActionListener buttonMoveClickedListener = new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                // Получаем имя кнопки перемещения
                String buttonName = ((JButton) e.getSource()).getName();

                // В зависимости от нажатой кнопки перемещаяем объект
                switch (buttonName) {
                    case ("ButtonUp"): {
                        _drawingBoat.MoveTransport(EnumDirection.Up);
                    }
                    break;
                    case ("ButtonDown"): {
                        _drawingBoat.MoveTransport(EnumDirection.Down);
                    }
                    break;
                    case ("ButtonLeft"): {
                        _drawingBoat.MoveTransport(EnumDirection.Left);
                    }
                    break;
                    case ("ButtonRight"): {
                        _drawingBoat.MoveTransport(EnumDirection.Right);
                    }
                    break;
                }

                // Перерисовываем содержимое
                Draw();
            }
        };

        ButtonUp.addActionListener(buttonMoveClickedListener);
        ButtonDown.addActionListener(buttonMoveClickedListener);
        ButtonLeft.addActionListener(buttonMoveClickedListener);
        ButtonRight.addActionListener(buttonMoveClickedListener);
    }

    // Метод отрисовки
    public void Draw() {
        // Если сущности внутри объекта отрисовки нет - выходим
        if (_drawingBoat.entityBoat == null) {
            return;
        }

        // Закрашиваем PictureBox цветом окна (очищаем его)
        Graphics g = PictureBox.getGraphics();
        g.setColor(PictureBox.getBackground());
        g.fillRect(0, 0, PictureBox.getWidth(), PictureBox.getHeight());

        // Рисуем объект
        _drawingBoat.DrawTransport(g);

        // Перерисовываем элементы управления (PictureBox закрашивает их)
        RepaintControls();
    }

    // Метод перерисовки элементов управления
    private void RepaintControls() {
        for (JComponent control : __controls) {
            control.repaint();
        }
    }

    // Метод инициализации списка элементов управления для их перерисовки
    private void InitializeControlsRepaintList() {
        __controls = new LinkedList<>();
        __controls.add(ButtonCreate);
        __controls.add(ButtonUp);
        __controls.add(ButtonDown);
        __controls.add(ButtonLeft);
        __controls.add(ButtonRight);
    }
}
